"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var Style = require("./style");
var react_1 = require("react");
var date_1 = require("../../../types/date");
var luxon_1 = require("luxon");
var lodash_1 = require("lodash");
var string_1 = require("../../../utilities/string");
var math_1 = require("../../../utilities/math");
var useClickOutside_1 = require("../../../hooks/useClickOutside");
var useCursor_1 = require("../../../hooks/useCursor");
var ArrowButton_1 = require("../../common/ArrowButton");
var react_2 = require("@emotion/react");
var props_1 = require("../../../utilities/props");
var useActive_1 = require("../../../hooks/useActive");
var DatePicker = function (props) {
    var handleSelect = props.handleSelect, _a = props.isMondayFirst, isMondayFirst = _a === void 0 ? true : _a, _b = props.isWeekendColor, isWeekendColor = _b === void 0 ? true : _b, listContainerStyle = props.listContainerStyle, listStyle = props.listStyle, itemStyle = props.itemStyle;
    var theme = (0, react_2.useTheme)();
    var _c = (0, useActive_1.default)(), active = _c.active, setActive = _c.setActive, handleActive = _c.handleActive;
    var _d = (0, react_1.useState)(new date_1.Date(luxon_1.DateTime.now())), date = _d[0], setDate = _d[1];
    var containerRef = (0, react_1.useRef)(null);
    var inputRef = (0, react_1.useRef)(null);
    var _e = (0, useCursor_1.default)(inputRef, date), cursor = _e.cursor, setCursor = _e.setCursor;
    (0, useClickOutside_1.default)(containerRef, setActive);
    var handleSelectClick = (0, react_1.useCallback)(function (item) {
        setActive(false);
        setDate(item);
        handleSelect(item);
    }, []);
    var handleChange = (0, react_1.useCallback)(function (e) {
        var _a, _b;
        var event = e.nativeEvent;
        if (!((_a = inputRef.current) === null || _a === void 0 ? void 0 : _a.selectionStart) || !event.data)
            return;
        var data = event.data;
        var cursor = ((_b = inputRef.current) === null || _b === void 0 ? void 0 : _b.selectionStart) - 1;
        var prevValue = e.target.defaultValue;
        var isCursorInsideYear = cursor >= 0 && cursor <= 3;
        if (isCursorInsideYear) {
            setDate(function (prev) {
                var newDate = lodash_1.default.cloneDeep(prev);
                var newYear = (0, string_1.replaceAt)(prevValue, cursor, data).slice(0, 4);
                newDate.set({ year: +newYear });
                return newDate;
            });
            setCursor(cursor === 3 ? 5 : cursor + 1);
        }
        var isCursorInsideMonth = cursor >= 5 && cursor <= 6;
        if (isCursorInsideMonth) {
            if (cursor === 5 && +data > 1) {
                setDate(function (prev) {
                    var newDate = lodash_1.default.cloneDeep(prev);
                    var newMonth = (0, string_1.replaceAt)(prevValue, cursor + 1, data).slice(5, 7);
                    newDate.set({ month: +newMonth % 10 });
                    return newDate;
                });
                setCursor(8);
            }
            else {
                setDate(function (prev) {
                    var newDate = lodash_1.default.cloneDeep(prev);
                    var newMonth = (0, string_1.replaceAt)(prevValue, cursor, data).slice(5, 7);
                    newDate.set({ month: +newMonth > 12 ? 12 : +newMonth });
                    return newDate;
                });
                setCursor(cursor === 6 ? 8 : cursor + 1);
            }
        }
        var isCursorInsideDay = cursor >= 8 && cursor <= 9;
        if (isCursorInsideDay) {
            if (cursor === 8 && +data > (0, math_1.quotient)(date.getLastDay(), 10)) {
                setDate(function (prev) {
                    var newDate = lodash_1.default.cloneDeep(prev);
                    var newMonth = (0, string_1.replaceAt)(prevValue, cursor + 1, data).slice(8);
                    newDate.set({ day: +newMonth % 10 });
                    return newDate;
                });
                setCursor(0);
            }
            else {
                setDate(function (prev) {
                    var newDate = lodash_1.default.cloneDeep(prev);
                    var newDay = (0, string_1.replaceAt)(prevValue, cursor, data).slice(8);
                    newDate.set({
                        day: +newDay > newDate.getLastDay() ? newDate.getLastDay() : +newDay,
                    });
                    return newDate;
                });
                setCursor(cursor === 9 ? 0 : cursor + 1);
            }
        }
    }, [date]);
    var handleFocus = (0, react_1.useCallback)(function (e) {
        setActive(true);
        // props.onFocus && props.onFocus(e);
    }, []);
    var WEEK_DAYS = lodash_1.default.cloneDeep(date_1.WEEK_DAY_ABBR);
    if (!isMondayFirst) {
        var LAST = WEEK_DAYS.pop();
        LAST && WEEK_DAYS.unshift(LAST);
    }
    var style = __assign(__assign({}, (0, props_1.getSizeProps)(props)), props.style);
    return ((0, jsx_runtime_1.jsxs)(Style.Container, __assign({ ref: containerRef, active: active, style: style }, { children: [(0, jsx_runtime_1.jsx)(Style.Input, { ref: inputRef, value: date.getFullString({ DateFormat: date_1.DATE_FORMAT.DASH }), onChange: handleChange, onFocus: handleFocus }), (0, jsx_runtime_1.jsx)(ArrowButton_1.default, { handleOpenClick: handleActive, isOpen: active, direction: active ? "Up" : "Down" }), active && ((0, jsx_runtime_1.jsxs)(Style.ListContainer, __assign({ style: listContainerStyle }, { children: [(0, jsx_runtime_1.jsxs)(Style.YearMonth, { children: [(0, jsx_runtime_1.jsx)(ArrowButton_1.default, { handleOpenClick: function () {
                                    return setDate(function (date) {
                                        var newDate = lodash_1.default.cloneDeep(date);
                                        newDate.plus({ month: -1 });
                                        return newDate;
                                    });
                                }, isOpen: active, direction: "Left" }), date.getYearMonthString({ DateFormat: date_1.DATE_FORMAT.DASH }), (0, jsx_runtime_1.jsx)(ArrowButton_1.default, { handleOpenClick: function () {
                                    return setDate(function (date) {
                                        var newDate = lodash_1.default.cloneDeep(date);
                                        newDate.plus({ month: 1 });
                                        return newDate;
                                    });
                                }, isOpen: active, direction: "Right" })] }), (0, jsx_runtime_1.jsx)(Style.WeekdayList, { children: WEEK_DAYS.map(function (item, index) {
                            var _a, _b;
                            var isSaturday = isMondayFirst ? index === 5 : index === 6;
                            var isSunday = isMondayFirst ? index === 6 : index === 0;
                            var weekendColor = (_a = theme.defaultColor) !== null && _a !== void 0 ? _a : "gray";
                            if (isSaturday)
                                weekendColor = "rgba(0, 0, 255, 0.5)";
                            if (isSunday)
                                weekendColor = "rgba(255, 0, 0, 0.5)";
                            return ((0, jsx_runtime_1.jsx)(Style.WeekdayItem, __assign({ style: {
                                    color: isWeekendColor
                                        ? weekendColor
                                        : (_b = theme.defaultColor) !== null && _b !== void 0 ? _b : "gray",
                                } }, { children: item }), index));
                        }) }), (0, jsx_runtime_1.jsx)(Style.DateList, __assign({ style: listStyle }, { children: (0, date_1.getCalendarDate)({
                            dateTime: date.getDateTime(),
                            isMondayFirst: isMondayFirst,
                        }).map(function (item, index) { return ((0, jsx_runtime_1.jsx)(Style.DateItem, __assign({ active: date.isEqualDate(item), onClick: function () { return handleSelectClick(item); }, style: itemStyle }, { children: item.getDay() }), index)); }) }))] })))] })));
};
exports.default = DatePicker;
