"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var Style = require("./style");
var react_1 = require("react");
var time_1 = require("../../../types/time");
var useClickOutside_1 = require("../../../hooks/useClickOutside");
var useSetScrollPosition_1 = require("../../../hooks/useSetScrollPosition");
var useCursor_1 = require("../../../hooks/useCursor");
var TimeType_1 = require("./TimeType");
var Hour_1 = require("./Hour");
var Min_1 = require("./Min");
var Seconds_1 = require("./Seconds");
var ArrowButton_1 = require("../../common/ArrowButton");
var props_1 = require("../../../utilities/props");
var useActive_1 = require("../../../hooks/useActive");
var TimePicker = function (props) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    var onChange = props.onChange, _k = props.is24Hour, is24Hour = _k === void 0 ? false : _k, _l = props.isSelectHour, isSelectHour = _l === void 0 ? true : _l, _m = props.isSelectMin, isSelectMin = _m === void 0 ? true : _m, _o = props.isSelectSeconds, isSelectSeconds = _o === void 0 ? false : _o, _p = props.showItemCount, showItemCount = _p === void 0 ? 8 : _p, listStyle = props.listStyle, itemStyle = props.itemStyle;
    var _q = (0, useActive_1.default)(), active = _q.active, setActive = _q.setActive, handleActive = _q.handleActive;
    var _r = (0, react_1.useState)(new time_1.Time({ hour: 0, min: 0, seconds: 0 })), time = _r[0], setTime = _r[1];
    var _s = (0, react_1.useState)(time_1.TIME_TYPE.AM), timeType = _s[0], setTimeType = _s[1];
    var _t = (0, react_1.useState)(12), hour = _t[0], setHour = _t[1];
    var _u = (0, react_1.useState)(0), min = _u[0], setMin = _u[1];
    var _v = (0, react_1.useState)(0), seconds = _v[0], setSeconds = _v[1];
    var containerRef = (0, react_1.useRef)(null);
    var inputRef = (0, react_1.useRef)(null);
    var timeTypeRef = (0, react_1.useRef)(null);
    var hourRef = (0, react_1.useRef)(null);
    var minRef = (0, react_1.useRef)(null);
    var secondsRef = (0, react_1.useRef)(null);
    var _w = (0, useCursor_1.default)(inputRef, time), cursor = _w.cursor, setCursor = _w.setCursor;
    (0, useClickOutside_1.default)(containerRef, setActive);
    (0, useSetScrollPosition_1.default)(hourRef, is24Hour
        ? hour * ((_b = (_a = hourRef.current) === null || _a === void 0 ? void 0 : _a.clientHeight) !== null && _b !== void 0 ? _b : 0)
        : (hour % 12) * ((_d = (_c = hourRef.current) === null || _c === void 0 ? void 0 : _c.clientHeight) !== null && _d !== void 0 ? _d : 0), active);
    (0, useSetScrollPosition_1.default)(minRef, min * ((_f = (_e = minRef.current) === null || _e === void 0 ? void 0 : _e.clientHeight) !== null && _f !== void 0 ? _f : 0), active);
    (0, useSetScrollPosition_1.default)(secondsRef, seconds * ((_h = (_g = secondsRef.current) === null || _g === void 0 ? void 0 : _g.clientHeight) !== null && _h !== void 0 ? _h : 0), active);
    (0, react_1.useEffect)(function () {
        var newTime = new time_1.Time({
            hour: !is24Hour
                ? timeType === time_1.TIME_TYPE.PM
                    ? hour + 12 === 24
                        ? 12
                        : hour + 12
                    : hour === 12
                        ? 0
                        : hour
                : hour,
            min: min,
            seconds: seconds,
        });
        setTime(newTime);
        onChange(newTime);
    }, [timeType, hour, min, seconds]);
    var handleChange = (0, react_1.useCallback)(function (e) {
        var _a, _b;
        var event = e.nativeEvent;
        if (!((_a = inputRef.current) === null || _a === void 0 ? void 0 : _a.selectionStart) || !event.data)
            return;
        var data = +event.data;
        var cursor = ((_b = inputRef.current) === null || _b === void 0 ? void 0 : _b.selectionStart) - 1;
        var standardPoint = 0;
        if (!is24Hour) {
            var isCursorInsideTimeType = cursor >= standardPoint && cursor <= standardPoint + 1;
            if (isCursorInsideTimeType) {
                setTimeType(data === 1 ? time_1.TIME_TYPE.AM : time_1.TIME_TYPE.PM);
                setCursor(standardPoint + 2);
            }
            standardPoint += 2;
        }
        else {
            standardPoint -= 1;
        }
        if (isSelectHour) {
            var isCursorInsideHourFirstDigit = cursor >= standardPoint && cursor <= standardPoint + 1;
            if (isCursorInsideHourFirstDigit) {
                if (data >= 0 && data <= 1) {
                    setHour(data * 10);
                    setCursor(standardPoint + 2);
                }
                else {
                    setHour(data);
                    setCursor(standardPoint + 4);
                }
            }
            var isCursorInsideHourSecondDigit = cursor === standardPoint + 2;
            if (isCursorInsideHourSecondDigit) {
                if (data >= 0 && data <= 2) {
                    setHour(function (prev) { return Math.floor(prev / 10) * 10 + data; });
                }
                else {
                    setHour(data);
                }
                setCursor(standardPoint + 4);
            }
            standardPoint += 3;
        }
        if (isSelectMin) {
            var isCursorInsideMinFirstDigit = cursor >= standardPoint && cursor <= standardPoint + 1;
            if (isCursorInsideMinFirstDigit) {
                if (data >= 0 && data <= 5) {
                    setMin(data * 10);
                    setCursor(standardPoint + 2);
                }
                else {
                    setMin(data);
                    setCursor(standardPoint + 4);
                }
            }
            var isCursorInsideMinSecondDigit = cursor === standardPoint + 2;
            if (isCursorInsideMinSecondDigit) {
                setMin(function (prev) { return Math.floor(prev / 10) * 10 + data; });
                setCursor(standardPoint + 4);
            }
            standardPoint += 3;
        }
        if (isSelectSeconds) {
            var isCursorInsideSecondsFirstDigit = cursor >= standardPoint && cursor <= standardPoint + 1;
            if (isCursorInsideSecondsFirstDigit) {
                if (data >= 0 && data <= 5) {
                    setSeconds(data * 10);
                    setCursor(standardPoint + 2);
                }
                else {
                    setSeconds(data);
                    setCursor(standardPoint + 3);
                }
            }
            var isCursorInsideSecondsSecondDigit = cursor === standardPoint + 2;
            if (isCursorInsideSecondsSecondDigit) {
                setSeconds(function (prev) { return Math.floor(prev / 10) * 10 + data; });
                setCursor(standardPoint + 3);
            }
            standardPoint += 2;
        }
        if (cursor === standardPoint) {
            setCursor(0);
        }
    }, [is24Hour, isSelectHour, isSelectMin, isSelectSeconds]);
    var handleFocus = (0, react_1.useCallback)(function (e) {
        setActive(true);
        // props.onFocus && props.onFocus(e);
    }, []);
    var style = __assign(__assign({}, (0, props_1.getSizeProps)(props)), props.style);
    return ((0, jsx_runtime_1.jsxs)(Style.Container, __assign({ ref: containerRef, active: active, style: style }, { children: [(0, jsx_runtime_1.jsx)(Style.Input, { ref: inputRef, value: !is24Hour
                    ? time.getString({
                        isPrintTimeType: true,
                        isPrintHour: isSelectHour,
                        isPrintMin: isSelectMin,
                        isPrintSeconds: isSelectSeconds,
                    })
                    : time.getString24Hour({
                        isPrintHour: isSelectHour,
                        isPrintMin: isSelectMin,
                        isPrintSeconds: isSelectSeconds,
                    }), onChange: handleChange, onFocus: handleFocus }), (0, jsx_runtime_1.jsx)(ArrowButton_1.default, { handleOpenClick: handleActive, isOpen: active, direction: active ? "Up" : "Down" }), active && ((0, jsx_runtime_1.jsxs)(Style.ListContainer, __assign({ itemHeight: (_j = itemStyle === null || itemStyle === void 0 ? void 0 : itemStyle.height) !== null && _j !== void 0 ? _j : "35px", showItemCount: showItemCount, style: listStyle }, { children: [!is24Hour && ((0, jsx_runtime_1.jsx)(TimeType_1.default, { timeTypeRef: timeTypeRef, timeType: timeType, setTimeType: setTimeType, listStyle: listStyle, itemStyle: itemStyle })), isSelectHour && ((0, jsx_runtime_1.jsx)(Hour_1.default, { hourRef: hourRef, hour: hour, setHour: setHour, is24Hour: is24Hour, listStyle: listStyle, itemStyle: itemStyle })), isSelectMin && ((0, jsx_runtime_1.jsx)(Min_1.default, { minRef: minRef, min: min, setMin: setMin, listStyle: listStyle, itemStyle: itemStyle })), isSelectSeconds && ((0, jsx_runtime_1.jsx)(Seconds_1.default, { secondsRef: secondsRef, seconds: seconds, setSeconds: setSeconds, listStyle: listStyle, itemStyle: itemStyle }))] })))] })));
};
exports.default = TimePicker;
